<?php
/*
Helper File for Plugin: Filedownload
Plugin URI: http://filedownload.blog-me.de/
Description: Database functions
Author: Peter Gross
Author URI: http://software-regensburg.de/

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

/**
 * Create database tables
 */
function filedownload_DBCreateTables() {
  require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
  require_once(ABSPATH . 'wp-includes/ms-blogs.php');
  
  global $wpdb;
  
  // create counter table
  $sql ="CREATE TABLE IF NOT EXISTS ".$wpdb->prefix."filedownload"." (
         id INT(10) NOT NULL AUTO_INCREMENT,
         filename VARCHAR(512) NOT NULL,
         count INT(10) NOT NULL,
         PRIMARY KEY (id)
        );";

  dbDelta($sql);

  // version 1.4: blog option "filedownload_allow_external_download"
  if (get_blog_option( get_current_blog_id(), "filedownload_allow_external_download", "not available" ) == "not available")
    add_blog_option( get_current_blog_id(), "filedownload_allow_external_download", "1"); // default "1" for compatibility to older versions
}

function filedownload_DBInsert($filename)
{
  global $wpdb;


  $query = 'SELECT * FROM '.$wpdb->prefix.'filedownload WHERE filename = \''.$filename.'\'';
  $result=$wpdb->get_row($query, ARRAY_A);
  if (count($result) == 0) 
  {
    $wpdb->insert( $wpdb->prefix.'filedownload', array( 'filename' => $filename, 'count' => 0 ), array( '%s', '%d' ));    
    return true;
  }
  else
  {
    return false;
  }
}

function filedownload_DBUpdate($filename)
{
  global $wpdb;


  $query = 'SELECT * FROM '.$wpdb->prefix.'filedownload WHERE filename = \''.$filename.'\'';
  $result=$wpdb->get_row($query, ARRAY_A);
  if (count($result) == 0) 
  {
    return false; 
  }
  else
  {
    $count = $result['count'] + 1;
    $wpdb->update( $wpdb->prefix.'filedownload', array( 'filename' => $filename, 'count' => $count ), array( 'filename' => $filename), array( '%s', '%d' ), array( '%s' ) );
    return true;    
  }
}

function filedownload_DBWrite($filename)
{
  global $wpdb;


  $query = 'SELECT * FROM '.$wpdb->prefix.'filedownload WHERE filename = \''.$filename.'\'';
  $result=$wpdb->get_row($query, ARRAY_A);
  if (count($result) == 0) 
  {
    $wpdb->insert( $wpdb->prefix.'filedownload', array( 'filename' => $filename, 'count' => 1 ), array( '%s', '%d' ));    
  }
  else
  {
    $count = $result['count'] + 1;
    $wpdb->update( $wpdb->prefix.'filedownload', array( 'filename' => $filename, 'count' => $count ), array( 'filename' => $filename), array( '%s', '%d' ), array( '%s' ) );    
  }
}

function filedownload_DBReset($filename)
{
  global $wpdb;

  $query = 'SELECT * FROM '.$wpdb->prefix.'filedownload WHERE filename = \''.$filename.'\'';
  $result=$wpdb->get_row($query, ARRAY_A);
  if (count($result) == 0) 
  {
    $wpdb->insert( $wpdb->prefix.'filedownload', array( 'filename' => $filename, 'count' => 0 ), array( '%s', '%d' ));    
  }
  else
  {
    $wpdb->update( $wpdb->prefix.'filedownload', array( 'filename' => $filename, 'count' => 0 ), array( 'filename' => $filename), array( '%s', '%d' ), array( '%s' ) );    
  }
}

function filedownload_DBDelete($filename)
{
  global $wpdb;

  $query = 'DELETE FROM '.$wpdb->prefix.'filedownload WHERE filename = \''.$filename.'\'';
  $result = $wpdb->query($query);
}

function filedownload_DBRead($filename)
{
  global $wpdb;

  $query = 'SELECT * FROM '.$wpdb->prefix.'filedownload WHERE filename = \''.$filename.'\'';
  $result=$wpdb->get_row($query, ARRAY_A);
  if (count($result) == 0) return false;
  return $result[count];
}

function filedownload_DBPathExists($filename)
{
  global $wpdb;

  $query = 'SELECT * FROM '.$wpdb->prefix.'filedownload WHERE filename = \''.$filename.'\'';
  $result=$wpdb->get_row($query, ARRAY_A);
  if (count($result) == 0) return false;
  else return true;
}


function filedownload_DBReadAll()
{
  global $wpdb;

  $query = 'SELECT * FROM '.$wpdb->prefix.'filedownload';
  $result=$wpdb->get_results($query, ARRAY_A);
  return $result;
}

function filedownload_exists($path)
{
  if(($open = @fopen ($path, "r")) === false) return false;
  else
  {
    fclose ($open);
    return true;
  }
}
?>
